#pragma once
#include "DllBase.h"


typedef struct urlinfo_t {
	CString       strUrl;
	CString       strUrlAct;
	CString       strScheme;
	CString       strHostName;
	CString       strUserName;
	CString       strPassword;
	INTERNET_PORT nPort;
	CString       strUrlPath;
	CString       strExtraInfo;
} URLINFO;

typedef URLINFO* LPURLINFO;
typedef const LPURLINFO LPCURLINFO;


class BASE_API CHTTPClient
{
private:
	CString  m_strUA;
	int      m_iBufSz;
	int      m_iMRSz;
	CStringA m_strRes;
	URLINFO  m_stUrl;

public:
	CHTTPClient(void) throw();
	virtual ~CHTTPClient(void) throw();
	BOOL SetUserAgent(LPCTSTR) throw();
	BOOL SetUserAgentIE(void) throw();
	BOOL GetUserAgent(CString&) const throw();
	BOOL SetBufferSize(int) throw();
	int  GetBufferSize(void) const throw();
	BOOL SetMaxResponseSize(int) throw();
	int  GetMaxResponseSize(void) const throw();
	BOOL IsSetResponse(void) const throw();
	void ClearResponse(void) throw();
	BOOL GetResponse(CStringA&) const throw();
	BOOL GetUrl(URLINFO&) const throw();
	BOOL SendRequest(LPCTSTR) throw();
	BOOL SendRequest(LPCURLINFO) throw();

public:
	static BOOL ParseUrl(LPCTSTR, LPURLINFO) throw();
	static BOOL DecodeUrl(LPCTSTR, CString&) throw();
	static BOOL EncodeUrl(LPCSTR, CStringA&) throw();
};
