#include "StdAfx.h"
#include "ModuleInfo.h"

CModuleInfo::CModuleInfo() throw()
{
	this->m_hInst = NULL;
}

CModuleInfo::~CModuleInfo() throw()
{
}

BOOL CModuleInfo::IsSet(void) const throw()
{
	return this->m_hInst != NULL;
}

HINSTANCE CModuleInfo::GetModuleHandle(void) const throw()
{
	return this->m_hInst;
}

BOOL CModuleInfo::GetFilePath(CString& strPath) const throw()
{
	_ATLTRY{
		if(!(this->IsSet())){
			return FALSE;
		}

		strPath = this->m_strFilePath;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}
	
	return TRUE;
}

BOOL CModuleInfo::GetDirPath(CString& strPath) const throw()
{
	_ATLTRY{
		if(!(this->IsSet())){
			return FALSE;
		}

		strPath = this->m_strDirPath;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}
	
	return TRUE;
}

BOOL CModuleInfo::GetFileInfo(WIN32_FIND_DATA& stInfo) const throw()
{
	if(!(this->IsSet())){
		return FALSE;
	}

	stInfo = this->m_stFileInfo;
	
	return TRUE;
}

BOOL CModuleInfo::Set(HINSTANCE hInst) throw()
{
	_ATLTRY{
		BOOL bRts;

		CString strFilePath;
		bRts = CModuleInfo::GetFilePath(hInst, strFilePath);
		if(!bRts){
			return FALSE;
		}

		CString strDirPath;
		bRts = CModuleInfo::GetDirPath(hInst, strDirPath);
		if(!bRts){
			return FALSE;
		}

		WIN32_FIND_DATA stFileInfo;
		bRts = CModuleInfo::GetFileInfo(hInst, stFileInfo);
		if(!bRts){
			return FALSE;
		}

		this->m_hInst       = hInst;
		this->m_strFilePath = strFilePath;
		this->m_strDirPath  = strDirPath;
		this->m_stFileInfo  = stFileInfo;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CModuleInfo::GetFilePath(HINSTANCE hInst, CString& strPath) throw()
{
	_ATLTRY{
		TCHAR cBuf[_MAX_PATH];

		DWORD dwLen = ::GetModuleFileName(hInst, cBuf, _MAX_PATH);
		if(dwLen <= 0){
			return FALSE;
		}

		strPath = cBuf;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CModuleInfo::GetDirPath(HINSTANCE hInst, CString& strPath) throw()
{
	_ATLTRY{
		errno_t iRts;

		CString strW;
		BOOL bRts = CModuleInfo::GetFilePath(hInst, strW);
		if(!bRts){
			return FALSE;
		}

		TCHAR cDriveBuf[_MAX_DRIVE];
		TCHAR cDirBuf[_MAX_DIR];
		iRts = _tsplitpath_s(strW, cDriveBuf, _MAX_DRIVE, cDirBuf, _MAX_DIR, NULL, 0, NULL, 0);
		if(iRts){
			return FALSE;
		}

		TCHAR cPathBuf[_MAX_PATH];
		iRts = _tmakepath_s(cPathBuf, _MAX_PATH, cDriveBuf, cDirBuf, NULL, NULL);
		if(iRts){
			return FALSE;
		}

		strPath = cPathBuf;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CModuleInfo::GetFileInfo(HINSTANCE hInst, WIN32_FIND_DATA& stFileInfo) throw()
{
	WIN32_FIND_DATA stFileInfoW;

	CString strFile;
	BOOL bRts = CModuleInfo::GetFilePath(hInst, strFile);
	if(!bRts){
		return FALSE;
	}

	HANDLE hFind = ::FindFirstFile(strFile, &stFileInfoW);
	if(!hFind){
		return FALSE;
	}

	::FindClose(hFind);

	stFileInfo = stFileInfoW;

	return TRUE;
}