#include "StdAfx.h"
#include "StringConv.h"


BOOL CStringConv::From(UINT uiCode, LPCSTR pSrc, CString& strDest) throw()
{
	_ATLTRY{
		int iLen;

		CStringA strSrc(pSrc);
		if(strSrc.GetLength() <= 0){
			strDest = _T("");
			return TRUE;
		}

		// 񒷂`FbNĂTCY蓖č쐬
		iLen = ::MultiByteToWideChar(uiCode, 0, strSrc, -1, NULL, 0);
		if(iLen <= 0){
			return FALSE;
		}

		CAutoVectorPtr<TCHAR> spDest;
		BOOL bRts = spDest.Allocate(iLen+1);
		if(!bRts){
			return FALSE;
		}

		iLen = ::MultiByteToWideChar(uiCode, 0, strSrc, -1, spDest, iLen);
		if(iLen <= 0){
			return FALSE;
		}

		strDest = spDest;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CStringConv::To(UINT uiCode, LPCTSTR pSrc, CStringA& strDest) throw()
{
	_ATLTRY{
		int iLen;

		CString strSrc(pSrc);
		if(strSrc.GetLength() <= 0){
			strDest = "";
			return TRUE;
		}

		// 񒷂`FbNĂTCY蓖č쐬
		iLen = ::WideCharToMultiByte(uiCode, 0, strSrc, -1, NULL, 0, NULL, NULL);
		if(iLen <= 0){
			return FALSE;
		}

		CAutoVectorPtr<CHAR> spDest;
		BOOL bRts = spDest.Allocate(iLen+1);
		if(!bRts){
			return FALSE;
		}
		
		iLen = ::WideCharToMultiByte(uiCode, 0, strSrc, -1, spDest, iLen, NULL, NULL);
		if(iLen <= 0){
			return FALSE;
		}

		strDest = spDest;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CStringConv::FromUTF8(LPCSTR pSrc, CString& strDest) throw()
{
	return CStringConv::From(CP_UTF8, pSrc, strDest);
}

BOOL CStringConv::ToUTF8(LPCTSTR pSrc, CStringA& strDest) throw()
{
	return CStringConv::To(CP_UTF8, pSrc, strDest);
}

BOOL CStringConv::FromANSI(LPCSTR pSrc, CString& strDest) throw()
{
	return CStringConv::From(CP_ACP, pSrc, strDest);
}

BOOL CStringConv::ToANSI(LPCTSTR pSrc, CStringA& strDest) throw()
{
	return CStringConv::To(CP_ACP, pSrc, strDest);
}

