#include "StdAfx.h"
#include "HTTPClientThread.h"


CHTTPClientThread::CHTTPClientThread(void)
{
}

CHTTPClientThread::~CHTTPClientThread(void)
{
}

BOOL CHTTPClientThread::IsSet(void)
{
	if(this->m_strIUrl.GetLength() <= 0){
		return FALSE;
	}

	return TRUE;
}

BOOL CHTTPClientThread::SetThreadData(LPCTSTR pstrIUrl, HWND hWndDstRes)
{
	_ATLTRY{
		CString strIUrl(pstrIUrl);
		if(strIUrl.GetLength() <= 0){
			return FALSE;
		}

		CWindow wndDstRes(hWndDstRes);
		if(!wndDstRes.IsWindow()){
			return FALSE;
		}

		this->m_strIUrl   = strIUrl;
		this->m_wndDstRes = wndDstRes;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

HRESULT CHTTPClientThread::Execute(DWORD_PTR dwParam, HANDLE hObject)
{
	CStringA strData;
	BOOL bRts = this->GetResponse(strData);
	if(!bRts){
		this->m_wndDstRes.SendMessage(WM_IURLLOAD);
		return E_FAIL;
	}

	this->m_wndDstRes.SendMessage(WM_IURLLOAD, reinterpret_cast<WPARAM>(&strData));
	return S_OK;
}

BOOL CHTTPClientThread::GetResponse(CStringA& strData)
{
	_ATLTRY{
		BOOL bRts;

		if(!(this->IsSet())){
			return FALSE;
		}

		CHTTPClient htc;
		bRts = htc.SetUserAgentIE();
		if(!bRts){
			return FALSE;
		}

		bRts = htc.SetMaxResponseSize(MAX_LITR);
		if(!bRts){
			return FALSE;
		}

		bRts = htc.SendRequest(this->m_strIUrl);
		if(!bRts){
			return FALSE;
		}

		CStringA strW;
		bRts = htc.GetResponse(strW);
		if(!bRts){
			return FALSE;
		}

		strData = strW;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

HRESULT CHTTPClientThread::CloseHandle(HANDLE hObject)
{
	BOOL bRts = ::CloseHandle(hObject);
	if(!bRts){
		return ::AtlHresultFromLastError();
	}

	return S_OK;
}