#include "StdAfx.h"
#include "resource.h"
#include "Pref.h"


CPref::CPref(void) throw()
{
}

CPref::~CPref(void) throw()
{
}

BOOL CPref::IsSet(void) const throw()
{
	if(this->m_strIUrl.GetLength() <= 0){
		return FALSE;
	}

	return TRUE;
}

BOOL CPref::GetInterfaceUrl(CString& strIUrl) const throw()
{
	_ATLTRY{
		if(!this->IsSet()){
			return FALSE;
		}

		strIUrl = this->m_strIUrl;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CPref::Set(LPCTSTR pstrIUrl) throw()
{
	_ATLTRY{
		CString strIUrl(pstrIUrl);
		if(strIUrl.GetLength() <= 0){
			return FALSE;
		}

		int iPos  = strIUrl.Find(_T("http://"));
		int iPoss = strIUrl.Find(_T("https://"));
		if(iPos != 0 && iPoss != 0){
			return FALSE;
		}

		this->m_strIUrl = strIUrl;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CPref::Load(void) throw()
{
	CRegKey reg;

	_ATLTRY{
		LONG lRts;

		CString strDItrUrl;
		BOOL bRts = strDItrUrl.LoadString(
			_AtlBaseModule.GetResourceInstance(),
			IDS_DEFITRURL
		);
		if(!bRts){
			return FALSE;
		}

		lRts = reg.Open(HKEY_CURRENT_USER, PREF_REGKEY, KEY_READ);
		if(lRts != ERROR_SUCCESS){
			this->m_strIUrl = strDItrUrl;
			reg.Close();
			return TRUE;
		}

		ULONG ulSize = 0;
		lRts = reg.QueryStringValue(PREF_REGITR, NULL, &ulSize);
		if(lRts != ERROR_SUCCESS){
			this->m_strIUrl = strDItrUrl;
			reg.Close();
			return TRUE;
		}
		else if(ulSize == 0){
			this->m_strIUrl = strDItrUrl;
			reg.Close();
			return TRUE;
		}

		CAutoVectorPtr<TCHAR> spcBuf;
		bRts = spcBuf.Allocate(ulSize);
		if(!bRts){
			::AtlThrow(E_FAIL);
		}

		lRts = reg.QueryStringValue(PREF_REGITR, spcBuf, &ulSize);
		if(lRts != ERROR_SUCCESS){
			::AtlThrow(E_FAIL);
		}

		this->m_strIUrl = spcBuf;

		reg.Close();
	}
	_ATLCATCH(e){
		e;
		reg.Close();
		return FALSE;
	}

	return TRUE;
}

BOOL CPref::Save(void) const throw()
{
	CRegKey reg;

	if(!this->IsSet()){
		return FALSE;
	}

	_ATLTRY{
		LONG lRts;

		lRts = reg.Create(HKEY_CURRENT_USER, PREF_REGKEY);
		if(lRts != ERROR_SUCCESS){
			::AtlThrow(E_FAIL);
		}

		ULONG ulSize = 0;
		lRts = reg.SetStringValue(PREF_REGITR, this->m_strIUrl, REG_SZ);
		if(lRts != ERROR_SUCCESS){
			::AtlThrow(E_FAIL);
		}

		reg.Close();
	}
	_ATLCATCH(e){
		e;
		reg.Close();
		return FALSE;
	}

	return TRUE;
}