#include "StdAfx.h"
#include "PrefDialog.h"
#include "Pref.h"

CPrefDialog::CPrefDialog()
{
}

CPrefDialog::~CPrefDialog()
{
}

BOOL CPrefDialog::SetPref(const CPref* pPref)
{
	_ATLTRY{
		if(!(pPref->IsSet())){
			return FALSE;
		}

		this->m_pref = *pPref;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CPrefDialog::GetPref(CPref& pref)
{
	_ATLTRY{
		pref = this->m_pref;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

LRESULT CPrefDialog::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CString strIUrl;
	BOOL bRts = this->m_pref.GetInterfaceUrl(strIUrl);
	if(!bRts){
		this->EndDialog(IDCANCEL);
		return 0;
	}

	this->GetDlgItem(IDC_EDITIURL).SetWindowText(strIUrl);
	return 0;
}

LRESULT CPrefDialog::OnEditIUrlChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	CString strIUrl;
	this->GetDlgItemText(IDC_EDITIURL, strIUrl);
	
	BOOL bRts = this->m_pref.Set(strIUrl);
	
	this->GetDlgItem(IDOK).EnableWindow(bRts);

	return 0;
}

LRESULT CPrefDialog::OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	this->EndDialog(IDOK);
	return 0;
}

LRESULT CPrefDialog::OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	this->EndDialog(IDCANCEL);
	return 0;
}