#include "StdAfx.h"
#include "ToolbarWnd.h"
#include "YSGToolbarBHO.h"
#include "YSGInterface.h"
#include "Pref.h"
#include "PrefDialog.h"
#include "AboutDialog.h"


CToolbarWnd::CToolbarWnd(void)
{
	// c[o[tH[JXݒ̂߂̃C^tF[XĂԂ߁A
	// c[o[NXBHONXւ̃|C^ێ
	this->m_pBHO      = NULL;
	this->m_hMenuPop  = NULL;
	this->m_bLoadLItr = FALSE;
}

CToolbarWnd::~CToolbarWnd(void)
{
	if(this->IsWindow()){
		this->DestroyWindow();
	}
}

LRESULT CToolbarWnd::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	BOOL bRts;

	this->GetDlgItem(IDC_BUTTONMENU).EnableWindow(FALSE);

	bRts = this->WaitEndThread();
	if(!bRts){
		return 0;
	}
	this->m_bLoadLItr = FALSE;

	this->m_hMenuPop = ::LoadMenu(
		_AtlBaseModule.GetResourceInstance(),
		MAKEINTRESOURCE(IDR_MENUPOPUP)
	);
	if(!this->m_hMenuPop){
		return 0;
	}

	this->GetDlgItem(IDC_BUTTONMENU).EnableWindow(TRUE);

	return 0;
}

LRESULT CToolbarWnd::OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if(this->m_hMenuPop){
		::DestroyMenu(this->m_hMenuPop);
		this->m_hMenuPop = NULL;
	}

	this->WaitEndThread();
	this->m_bLoadLItr = FALSE;

	return 0;
}

LRESULT CToolbarWnd::OnDocComp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	_ATLTRY{
		CString* pstrSGU = reinterpret_cast<CString*>(wParam);
		this->m_strSGU   = *pstrSGU;
	}
	_ATLCATCH(e){
		e;
		return 0;
	}

	this->ControlLoginButton();

	return 0;
}

LRESULT CToolbarWnd::OnIUrlLoad(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	_ATLTRY{
		BOOL bRts;

		CStringA* pstrData = reinterpret_cast<CStringA*>(wParam);
		if(!pstrData){
			::AtlThrow(E_FAIL);
		}

		CString strId;
		CString strPass;
		struct {
			int      iCtl;
			CString* pstrDest;
		} stCtlTbl[] = {
			{ IDC_EDITID, &strId },
			{ IDC_EDITPS, &strPass },
			{ -1,         NULL }
		};

		for(int i = 0; stCtlTbl[i].iCtl != -1; i++){
			this->GetDlgItemText(stCtlTbl[i].iCtl, *(stCtlTbl[i].pstrDest));
		}

		CYSGInterface itr;
		bRts = itr.SetServerUrl(this->m_strSGU, strId, strPass, *pstrData);
		if(!bRts){
			::AtlThrow(E_FAIL);
		}

		bRts = this->Navigate(&itr);
		if(!bRts){
			::AtlThrow(E_FAIL);
		}

		// Note:
		// Xbh̕Â߁Ay[W̊Ԉړ\̂ŁA
		// OC{^Lǂ`FbNȂ
		this->m_bLoadLItr = FALSE;
		this->ControlLoginButton();
	}
	_ATLCATCH(e){
		e;
		this->m_bLoadLItr = FALSE;
		this->ControlLoginButton();
		return 0;
	}

	return 0;
}

LRESULT CToolbarWnd::OnEditSetFocus(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(!this->m_pBHO){
		return 0;
	}

	this->m_pBHO->HaveFocus(TRUE);

	return 0;
}

LRESULT CToolbarWnd::OnButtonLoginClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	this->GetDlgItem(IDC_BUTTONLOGIN).EnableWindow(FALSE);

	_ATLTRY{
		BOOL    bRts;
		HRESULT hr;

		// Note:
		// [h̃tOIɂāAXbhɂf[^擾ɂ
		// OC{^𔽉Ȃ悤ɂB
		this->m_bLoadLItr = TRUE;

		bRts = this->m_pref.Load();
		if(!bRts){
			::AtlThrow(E_FAIL);
		}

		CString strIUrl;
		bRts = this->m_pref.GetInterfaceUrl(strIUrl);
		if(!bRts){
			::AtlThrow(E_FAIL);
		}

		bRts = this->WaitEndThread();
		if(!bRts){
			::AtlThrow(E_FAIL);
		}

		hr = this->m_thread.Initialize();
		if(FAILED(hr)){
			return 0;
		}

		HANDLE hEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL);
		if(!hEvent){
			::AtlThrow(E_FAIL);
		}
		
		hr = this->m_thread.AddHandle(hEvent, &(this->m_thcli), NULL);
		if(FAILED(hr)){
			::CloseHandle(hEvent);
			hEvent = NULL;
			::AtlThrow(E_FAIL);
		}

		bRts = this->m_thcli.SetThreadData(strIUrl, this->m_hWnd);
		if(!bRts){
			::AtlThrow(E_FAIL);
		}

		bRts = ::SetEvent(hEvent);
		if(!bRts){
			::AtlThrow(E_FAIL);
		}
	}
	_ATLCATCH(e){
		e;
		this->WaitEndThread();
		this->m_bLoadLItr = FALSE;
 		this->GetDlgItem(IDC_BUTTONLOGIN).EnableWindow(TRUE);
		return 0;
	}

	return 0;
}

LRESULT CToolbarWnd::OnButtonMenuClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	BOOL bRts;

	HMENU hSubMenu = ::GetSubMenu(this->m_hMenuPop, 0);
	if(!hSubMenu){
		return 0;
	}

	RECT stBtnPos;
	bRts = this->GetDlgItem(IDC_BUTTONMENU).GetWindowRect(&stBtnPos);
	if(!bRts){
		return 0;
	}
	
	bRts = ::TrackPopupMenu(hSubMenu, TPM_LEFTALIGN, stBtnPos.right, stBtnPos.top, 0, this->m_hWnd, NULL);
	if(!bRts){
		return 0;
	}

	return 0;
}

LRESULT CToolbarWnd::OnMenuPref(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// Note:
	// IE7ȍ~̓^uƂɃvZX̂ŁA
	// 񃍁[hAZ[uȂƁA
	// ݒύXƂɐݒ肪vȂȂ
	this->m_pref.Load();

	CPrefDialog dlg;
	dlg.SetPref(&(this->m_pref));
	INT_PTR iRts = dlg.DoModal(this->m_hWnd, 0);
	if(iRts != IDOK){
		return 0;
	}
	
	BOOL bRts = dlg.GetPref(this->m_pref);
	if(!bRts){
		return 0;
	}

	this->m_pref.Save();

	return 0;
}

LRESULT CToolbarWnd::OnMenuAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	CAboutDialog dlg;
	dlg.DoModal(this->m_hWnd, 0);

	return 0;
}

LRESULT CToolbarWnd::OnMenuHome(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	_ATLTRY{
		BOOL bRts;

		if(!this->m_pBHO){
			return 0;
		}

		CString strHUrl;
		strHUrl.LoadString(
			_AtlBaseModule.GetResourceInstance(),
			IDS_HOMEURL
		);
		if(strHUrl.GetLength() <= 0){
			return 0;
		}

		CComPtr<IWebBrowser2> spWB;
		bRts = this->m_pBHO->GetWebBrowser(spWB);
		if(!bRts){
			return 0;
		}

		CComBSTR    strUrl(strHUrl);
		CComVariant vEmpty;
		CComVariant vFlags(navNoReadFromCache);
		HRESULT hr = spWB->Navigate(strUrl, &vFlags, &vEmpty, &vEmpty, &vEmpty);
		if(FAILED(hr)){
			return 0;
		}
	}
	_ATLCATCH(e){
		e;
		return 0;
	}

	return 0;
}

BOOL CToolbarWnd::Navigate(CYSGInterface* pItr)
{
	_ATLTRY{
		BOOL bRts;

		if(!this->m_pBHO){
			return FALSE;
		}

		CString strSUrl;
		bRts = pItr->GetServerUrl(strSUrl);
		if(!bRts){
			return FALSE;
		}

		URLINFO stSUrlInfo;
		bRts = CHTTPClient::ParseUrl(strSUrl, &stSUrlInfo);
		if(!bRts){
			return FALSE;
		}

		CComPtr<IWebBrowser2> spWB;
		bRts = this->m_pBHO->GetWebBrowser(spWB);
		if(!bRts){
			return FALSE;
		}

		CComBSTR    strUrl(stSUrlInfo.strUrlAct);
		CComVariant vEmpty;
		CComVariant vFlags(navNoReadFromCache | navNoWriteToCache);
		CComVariant vHeader;
		CComVariant vPost;
		if(stSUrlInfo.strExtraInfo.GetLength() > 0){
			vHeader = "Content-type: application/x-www-form-urlencoded\r\n";
			bRts    = CToolbarWnd::ConvertPostData(stSUrlInfo.strExtraInfo, vPost);
			if(!bRts){
				return FALSE;
			}
		}

		HRESULT hr = spWB->Navigate(strUrl, &vFlags, &vEmpty, &vPost, &vHeader);
		if(FAILED(hr)){
			return FALSE;
		}
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

void CToolbarWnd::ControlLoginButton(void)
{
	// Note:
	// Xbhɂ郍OC̏ꍇ̓OC{^
	// ׂĖ
	if(this->m_bLoadLItr){
		return;
	}

	this->GetDlgItem(IDC_BUTTONLOGIN).EnableWindow(
		!this->m_strSGU.IsEmpty()
	);
}

BOOL CToolbarWnd::WaitEndThread(void)
{
	HRESULT hr = this->m_thread.Shutdown();
	if(FAILED(hr)){
		return FALSE;
	}

	return TRUE;
}

BOOL CToolbarWnd::ConvertPostData(LPCTSTR pstrPost, CComVariant& vPost)
{
	_ATLTRY{
		CString strPost(pstrPost);
		if(strPost.GetLength() <= 0){
			vPost.Clear();
			return TRUE;
		}

		// Postf[^ANSIɕϊđMKv
		CStringA strPostA;
		BOOL bRts = CStringConv::ToANSI(strPost, strPostA);
		if(!bRts){
			return FALSE;
		}

		// Variant̔zf[^ϊ
		ULONG ulSize = strPostA.GetLength();
		CComSafeArray<byte> cBuf;
		HRESULT hr = cBuf.Add(ulSize, reinterpret_cast<byte*>(strPostA.GetBuffer()), TRUE);
		if(FAILED(hr)){
			return FALSE;
		}

		// eRs[Ċi[
		vPost = cBuf;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

