#pragma once
#include "atlwin.h"
#include "Resource.h"
#include "YSGInterface.h"
#include "Pref.h"
#include "HTTPClientThread.h"


class CYSGToolbarBHO;


class CToolbarWnd :
	public CDialogImpl<CToolbarWnd>
{
public:
	enum { IDD = IDD_DIALOGBAR };

	CYSGToolbarBHO* m_pBHO;

	BEGIN_MSG_MAP(CToolbarWindow)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_DOCCOMP, OnDocComp)
		MESSAGE_HANDLER(WM_IURLLOAD, OnIUrlLoad)
		COMMAND_CODE_HANDLER(EN_SETFOCUS, OnEditSetFocus)
		COMMAND_HANDLER(IDC_BUTTONLOGIN, BN_CLICKED, OnButtonLoginClick)
		COMMAND_HANDLER(IDC_BUTTONMENU, BN_CLICKED, OnButtonMenuClick)
		COMMAND_HANDLER(ID_MENUPREF, BN_CLICKED, OnMenuPref)
		COMMAND_HANDLER(ID_MENUABOUT, BN_CLICKED, OnMenuAbout)
		COMMAND_HANDLER(ID_MENUHOME, BN_CLICKED, OnMenuHome)
	END_MSG_MAP()

	CToolbarWnd(void);
	virtual ~CToolbarWnd(void);

	LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnDocComp(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnIUrlLoad(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnEditSetFocus(WORD, WORD, HWND, BOOL&);
	LRESULT OnButtonLoginClick(WORD, WORD, HWND, BOOL&);
	LRESULT OnButtonMenuClick(WORD, WORD, HWND, BOOL&);
	LRESULT OnMenuPref(WORD, WORD, HWND, BOOL&);
	LRESULT OnMenuAbout(WORD, WORD, HWND, BOOL&);
	LRESULT OnMenuHome(WORD, WORD, HWND, BOOL&);
	BOOL Navigate(CYSGInterface*);

private:
	CPref                            m_pref;
	CString                          m_strSGU;
	HMENU                            m_hMenuPop;
	BOOL                             m_bLoadLItr;
	CWorkerThread<Win32ThreadTraits> m_thread;
	CHTTPClientThread                m_thcli;

private:
	void ControlLoginButton(void);
	BOOL WaitEndThread(void);

public:
	static BOOL ConvertPostData(LPCTSTR, CComVariant&);
};
