#pragma once
#include "stdafx.h"

typedef struct ysgitrq_t {
	CString strKey;
	CString strVal;
} YSGITRQ;

typedef struct ysgitr_t {
	CString               strServer;
	CString               strServiceKey;
	CString               strIIDKey;
	CString               strIID;
	CString               strIDKey;
	CString               strPassKey;
	CString               strPassChal;
	CSimpleArray<YSGITRQ> listQuery;
} YSGITR;

typedef YSGITR* LPYSGITR;
typedef const LPYSGITR LPCYSGITR;


class CYSGInterface
{
private:
	CString m_strSUrl;

public:
	CYSGInterface(void);
	virtual ~CYSGInterface(void);
	BOOL GetServerUrl(CString&);
	BOOL SetServerUrl(LPCTSTR, LPCTSTR, LPCTSTR, LPCSTR);

public:
	static BOOL ParseXML(CComPtr<IXMLDOMDocument>, YSGITR&);
	static BOOL GetNodeValue(CComPtr<IXMLDOMNode>, LPCTSTR, CString&);
	static BOOL CreateUrl(LPCTSTR, LPCTSTR, LPCTSTR, LPCYSGITR, CString&);
	static BOOL CheckYSGItr(LPCYSGITR);
	static BOOL EncodeUrl(LPCTSTR, CString&);
	static BOOL EncodeUrl(LPCYSGITR, YSGITR&);
	static BOOL CreateChalRes(LPCTSTR, LPCTSTR, CString&);
};
