// YSGToolbarBHO.cpp : CYSGToolbarBHO ̎

#include "stdafx.h"
#include "dllmain.h"
#include "YSGToolbarBHO.h"


// CYSGToolbarBHO

BOOL CYSGToolbarBHO::CreateResourcePath(CString& strPath)
{
	_ATLTRY{
		BOOL bRts;

		CModuleInfo module;
		bRts = module.Set(_hInstance);
		if(!bRts){
			return FALSE;
		}

		bRts = module.GetDirPath(strPath);
		if(!bRts){
			return FALSE;
		}

		strPath += CString(_T("\\")) + INTR_RES;
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

BOOL CYSGToolbarBHO::CreateToolWindow(HWND hWndParent)
{
	BOOL bRts;
	RECT rect;

	::GetClientRect(hWndParent, &rect);
	this->m_wndControl.Create(hWndParent, rect, NULL, WS_CHILD);
	
	bRts = this->m_wndControl.m_wndToolbar.IsWindow();
	if(!bRts){
		return FALSE;
	}

	bRts = this->m_wndControl.m_wndToolbar.GetClientRect(&rect);
	if(!bRts){
		return FALSE;
	}

	this->m_lWndHeight = rect.bottom - rect.top;

	return TRUE;
}

BOOL CYSGToolbarBHO::CheckFocusEditControl(void)
{
	HWND    hWnd;

	hWnd = ::GetFocus();

	CWindow wndEdit;
	int     nIDTbl[] = {IDC_EDITID, IDC_EDITPS, -1};
	for(int i = 0; nIDTbl[i] != -1; i++){
		wndEdit = this->m_wndControl.m_wndToolbar.GetDlgItem(nIDTbl[i]);
		if(hWnd == wndEdit.m_hWnd){
			return TRUE;
		}
	}

	return TRUE;
}

void CYSGToolbarBHO::FocusNextControl(void)
{
	// ^uL[ɂĎ̃tB[hɃtH[JXړ
	HWND hWndFocus = ::GetFocus();

	int iCtlTbl[] = {
		IDC_EDITID,
		IDC_EDITPS
	};
	int iCtlTblLen = 2;

	int  i;
	HWND hWndCtl = NULL;
	for(i = 0; i < iCtlTblLen; i++){
		hWndCtl = this->m_wndControl.m_wndToolbar.GetDlgItem(iCtlTbl[i]);
		if(hWndCtl == hWndFocus){
			break;
		}
	}
	if(i >= iCtlTblLen){
		return;
	}

	i++;
	if(i >= iCtlTblLen){
		i = 0;
	}

	CWindow wndCtl = this->m_wndControl.m_wndToolbar.GetDlgItem(iCtlTbl[i]);
	wndCtl.SetFocus();
}

void CYSGToolbarBHO::LoginControl(void)
{
	CWindow wndCtl = this->m_wndControl.m_wndToolbar.GetDlgItem(IDC_BUTTONLOGIN);
	
	// Note:
	// Message̓Rg[Disableł邽߁AOɃ`FbNKv
	LONG_PTR lStyle = wndCtl.GetWindowLongPtr(GWL_STYLE);
	if(lStyle & WS_DISABLED){
		return;
	}

	wndCtl.PostMessage(BM_CLICK);
}

BOOL CYSGToolbarBHO::parseDocument(IDispatch* pDisp, CString& strSGU)
{
	_ATLTRY{
		HRESULT hr;

		// IWebBrowser2̃C^tF[X擾
		CComQIPtr<IWebBrowser2> spTempWebBrowser = pDisp;

		// ŏʃx̃uEUɊ֘AtꂽCxgǂB
		if(!spTempWebBrowser || !this->m_spWebBrowser || !(this->m_spWebBrowser.IsEqualObject(spTempWebBrowser))){
			return FALSE;
		}

		// uEU猻݂ document IuWFNg擾܂...
		CComPtr<IDispatch> spDispDoc;
		hr = this->m_spWebBrowser->get_Document(&spDispDoc);
		if(FAILED(hr)){
			return FALSE;
		}
		
		// ...HTML hLgɏƉ܂B
		CComQIPtr<IHTMLDocument3> spHTMLDoc = spDispDoc;
		if(spHTMLDoc == NULL){
			return FALSE;
		}

		// ^^O̎擾
		CComPtr<IHTMLElementCollection> spMetaCol;
		CComBSTR bstrMeta(_T("meta"));
		hr = spHTMLDoc->getElementsByTagName(bstrMeta, &spMetaCol);
		if(FAILED(hr)){
			return FALSE;
		}

		LONG lcnt;
		hr = spMetaCol->get_length(&lcnt);
		if(FAILED(hr) || lcnt <= 0){
			return FALSE;
		}

		// ysg^ǑƓe̎擾
		CComPtr<IDispatch> spDispElm;
		CComVariant vtIndex;
		CComQIPtr<IHTMLMetaElement> spMetaElm;
		CComBSTR bstrW;
		for(LONG i = 0; i < lcnt; i++){
			vtIndex = i;

			spDispElm.Release();
			hr = spMetaCol->item(vtIndex, vtIndex, &spDispElm);
			if(FAILED(hr)){
				return FALSE;
			}
			spMetaElm = spDispElm;

			bstrW.Empty();
			hr = spMetaElm->get_name(&bstrW);
			if(FAILED(hr)){
				return FALSE;
			}
			bstrW.ToLower();
			if( bstrW != _T("ysg") ){
				continue;
			}

			bstrW.Empty();
			hr = spMetaElm->get_content(&bstrW);
			if(FAILED(hr)){
				return FALSE;
			}

			strSGU = bstrW;
			break;
		}
	}
	_ATLCATCH(e){
		e;
		return FALSE;
	}

	return TRUE;
}

void CYSGToolbarBHO::HaveFocus(BOOL bFocus)
{
	if(!(this->m_spInpObjSite)){
		return;
	}

	IUnknown* pUnk;
	HRESULT hr = this->QueryInterface(IID_IUnknown, (void**)&pUnk);
	if(FAILED(hr)){
		return;
	}
	
	this->m_spInpObjSite->OnFocusChangeIS(pUnk, bFocus);

	pUnk->Release();
}

BOOL CYSGToolbarBHO::GetWebBrowser(CComPtr<IWebBrowser2>& spWebBrowser)
{
	if(this->m_spWebBrowser == NULL){
		return FALSE;
	}

	spWebBrowser = this->m_spWebBrowser;
	if(!spWebBrowser){
		return FALSE;
	}

	return TRUE;
}



///////////////////////////////////////////////////////////////////////////
//
// C^tF[X IDispEventImpl
//

STDMETHODIMP CYSGToolbarBHO::OnDocumentComplete(IDispatch *pDisp, VARIANT *pvarURL)
{
	_ATLTRY{
		CString strSGU;
		this->parseDocument(pDisp, strSGU);

		// c[o[ɃhLg[h
		this->m_wndControl.m_wndToolbar.SendMessage(WM_DOCCOMP, (LPARAM)&strSGU, (WPARAM)0);
	}
	_ATLCATCH(e){
		e;
		return E_FAIL;
	}

	// Note: CxgVN̖߂l͖̂ŁAȂłOK
	return S_OK;
}



///////////////////////////////////////////////////////////////////////////
//
// C^tF[X IObjectWithSite
//

STDMETHODIMP CYSGToolbarBHO::SetSite(IUnknown* pUnkSite)
{
	HRESULT hr;

	if(pUnkSite != NULL){
		// ۉ̂߃\[XDLLǂݍ
		if(!(this->m_hResource)){
			CString strPath;
			this->CreateResourcePath(strPath);

			this->m_hResource = ::LoadLibrary(strPath);
		}
		if(!(this->m_hOldResource) && this->m_hResource){
			this->m_hOldResource = _AtlBaseModule.SetResourceInstance(this->m_hResource);
		}

		// Note: http://msdn.microsoft.com/ja-jp/library/bb250489%28VS.85%29.aspx
		// IWebBrowser2 ւ̃|C^LbV܂B
		if(!(this->m_spWebBrowser)){
			// IServiceProvideroRIWebBrowser2擾܂B
			CComQIPtr<IServiceProvider> spServiceProvider(pUnkSite);
			if (!spServiceProvider){
				return E_FAIL;
			}

			CComPtr<IWebBrowser2> spWebBrowser;
			hr = spServiceProvider->QueryService(SID_SWebBrowserApp, &spWebBrowser);
			if(FAILED(hr)){
				return E_FAIL;
			}

			hr = this->DispEventAdvise(spWebBrowser);
			if(FAILED(hr)){
				return E_FAIL;
			}

			this->m_spWebBrowser = spWebBrowser;
		}

		// tH[JX𐧌䂷邽߂̃C^tF[X擾
		if(!(this->m_spInpObjSite)){
			CComQIPtr<IInputObjectSite> spInpObjSite(pUnkSite);
			if(!spInpObjSite){
				return E_FAIL;
			}

			this->m_spInpObjSite = spInpObjSite;
		}
	}
	else{
		// Cxg VN̓o^𖕏܂B
		if(this->m_spWebBrowser){
			this->DispEventUnadvise(this->m_spWebBrowser);
			this->m_spWebBrowser.Release();
		}

		// tH[JXpC^tF[X폜
		if(this->m_spInpObjSite){
			this->m_spInpObjSite.Release();
		}

		// \[XJ
		if(this->m_hOldResource){
			_AtlBaseModule.SetResourceInstance(this->m_hOldResource);
		}
		if(this->m_hResource){
			::FreeResource(this->m_hResource);
		}
	}

	return IObjectWithSiteImpl<CYSGToolbarBHO>::SetSite(pUnkSite);
}



///////////////////////////////////////////////////////////////////////////
//
// C^tF[X IDeskBand
//

STDMETHODIMP CYSGToolbarBHO::GetBandInfo(DWORD /* dwBandID */, DWORD /* dwViewMode */, DESKBANDINFO* pdbi)
{
	if(!pdbi){
		return E_INVALIDARG;
	}

	LONG lHeight = 24;	// Ƃ肠̃ftHg̍
	if(this->m_lWndHeight != 0){
		lHeight = this->m_lWndHeight;
	}

    if(pdbi->dwMask & DBIM_MINSIZE){
		pdbi->ptMinSize.x = 400;
		pdbi->ptMinSize.y = lHeight;
	}

    if(pdbi->dwMask & DBIM_MAXSIZE){
		pdbi->ptMaxSize.x = -1;
		pdbi->ptMaxSize.y = lHeight;
	}

    if(pdbi->dwMask & DBIM_INTEGRAL){
		pdbi->ptIntegral.x = 1;
		pdbi->ptIntegral.y = 1;
	}

    if(pdbi->dwMask & DBIM_ACTUAL){
		pdbi->ptActual.x = -1;
		pdbi->ptActual.y = lHeight;
	}

    if(pdbi->dwMask & DBIM_TITLE){
		pdbi->wszTitle[0] = _T('\0');
    }

    if(pdbi->dwMask & DBIM_BKCOLOR){
		pdbi->dwMask &= ~DBIM_BKCOLOR;
	}

	if (pdbi->dwMask & DBIM_MODEFLAGS){
		pdbi->dwModeFlags = DBIMF_NORMAL | DBIMF_USECHEVRON | DBIMF_BREAK;
	}

	return S_OK;
}



///////////////////////////////////////////////////////////////////////////
//
// C^tF[X IOleWindow
//

STDMETHODIMP CYSGToolbarBHO::GetWindow(HWND* phWnd)
{
	// EChEnhʒm
	// EBhEȂ΍쐬A΁ÃnhԂB

	if(this->m_wndControl.m_wndToolbar.IsWindow()){
		*phWnd = this->m_wndControl.m_wndToolbar.m_hWnd;
		return S_OK;
	}

	// this->m_spUnkSiteIObjectWithSite::SetSiteĂ΂ꂽƂ
	// IɃZbg
	CComQIPtr<IOleWindow> spOLEWnd(this->m_spUnkSite);
	if(spOLEWnd == NULL){
		return E_FAIL;
	}

	HWND hWndParent;
	HRESULT hr = spOLEWnd->GetWindow(&hWndParent);
	if(FAILED(hr) || !::IsWindow(hWndParent)){
		return E_FAIL;
	}

	BOOL bRts = this->CreateToolWindow(hWndParent);
	if(!bRts){
		return E_FAIL;
	}

	*phWnd = this->m_wndControl.m_wndToolbar.m_hWnd;

	return S_OK;
}

STDMETHODIMP CYSGToolbarBHO::ContextSensitiveHelp(BOOL /* fEnterMode */)
{
	ATLTRACENOTIMPL("IOleWindow::ContextSensitiveHelp");
}



///////////////////////////////////////////////////////////////////////////
//
// C^tF[X IDockingWindow
//

STDMETHODIMP CYSGToolbarBHO::ShowDW(BOOL bShow)
{
	int iMode;
	if(bShow){
		iMode = SW_SHOW;
	}
	else{
		iMode = SW_HIDE;
	}

	this->m_wndControl.m_wndToolbar.ShowWindow(iMode);

	return S_OK;
}

STDMETHODIMP CYSGToolbarBHO::CloseDW(unsigned long dwReserved)
{
	this->ShowDW(FALSE);

	return S_OK;
}

STDMETHODIMP CYSGToolbarBHO::ResizeBorderDW(const RECT* prcBorder, IUnknown* punkToolbarSite, BOOL bReserved)
{
	ATLTRACENOTIMPL("IDockingWindow::ResizeBorderDW");
}



///////////////////////////////////////////////////////////////////////////
//
// C^tF[X IInputObject
//

STDMETHODIMP CYSGToolbarBHO::HasFocusIO(void)
{
	HWND hWnd = ::GetFocus();

	if(hWnd == this->m_wndControl.m_wndToolbar.m_hWnd){
		return S_OK;
	}
	
	BOOL bRts = this->CheckFocusEditControl();
	if(bRts){
		return S_OK;
	}

	return S_FALSE;
}

STDMETHODIMP CYSGToolbarBHO::TranslateAcceleratorIO(LPMSG lpMsg)
{
	int nVirtKey = (int)(lpMsg->wParam);
	if(lpMsg->message == WM_KEYUP){
		if(nVirtKey == VK_TAB){
			this->FocusNextControl();
		}
		else if(nVirtKey == VK_RETURN){
			this->LoginControl();
		}
	}

	::TranslateMessage(lpMsg);
	::DispatchMessage(lpMsg);

	return S_OK;
}

STDMETHODIMP CYSGToolbarBHO::UIActivateIO(BOOL bActivate, LPMSG lpMsg)
{
	if(bActivate){
		this->m_wndControl.m_wndToolbar.GetDlgItem(IDC_EDITID).SetFocus();
	}

	return S_OK;
}
